

CompilerIf Defined(False, #PB_Procedure) = #False
Procedure False(Value)
  If Value = 0
    ProcedureReturn #True
  EndIf
EndProcedure
CompilerEndIf 


Procedure Alert(msg.s, options = 0)
  ProcedureReturn MessageRequester(#PROJECT_NAME$+" - "+Translate("Error"), msg, #MB_ICONWARNING | options)
EndProcedure



CompilerIf Defined(Path_Combine, #PB_Procedure) = #False
Procedure.s Path_Combine(path1.s, path2.s)
  CompilerIf #PB_Compiler_OS = #PB_OS_Windows
    Separator.s = "\"
  CompilerElse
    Separator.s = "/"
  CompilerEndIf
  
  If Len(path2) = 0
    ProcedureReturn path1
  EndIf
  If Len(path1) = 0
    ProcedureReturn path2
  EndIf
  If Right(path1, 1) <> Separator And Left(path2, 1) <> Separator
    ProcedureReturn path1 + Separator + path2
  EndIf
  ProcedureReturn path1 + path2
EndProcedure
CompilerEndIf


; ###################################################################################
;- ___ Math functions  _________
; ###################################################################################

Procedure Preg_match(reg$, val$)
  Protected hReg.l, res.l
  hReg = CreateRegularExpression(#PB_Any, reg$)
  res = MatchRegularExpression(hReg, val$)
  FreeRegularExpression(hReg)
  ProcedureReturn res
EndProcedure

Procedure IsInteger_(val$)
  ProcedureReturn Preg_match("^\d+$", val$)
EndProcedure

Procedure IsFloat_(val$)
  ProcedureReturn Preg_match("^\d+(\,|\.)?\d+$", val$)
EndProcedure


; ###################################################################################
;- ___ Convertit une taille de fichier en String  ________
; ###################################################################################


Procedure.s SizeToStr(octets.l)
  If octets<1
    ProcedureReturn "0 "+Translate("Byte")
  EndIf
  Size.f = octets
  strSize$ = " o"
  If Size > 1024
    Size / 1024
    strSize$ = " Ko"
    If Size > 1024
      Size / 1024
      strSize$ = " Mo"
      If Size > 1024
        Size / 1024
        strSize$ = " Go"
      EndIf
    EndIf
  EndIf
  ProcedureReturn StrF(Size,1)+strSize$
EndProcedure


Procedure InverseCheckBox(GadgetID, index)
  Protected Value, Selected
  
  Value = GetGadgetItemState(GadgetID, index)
  If Value & #PB_ListIcon_Selected
    Selected = #PB_ListIcon_Selected
  EndIf
  If Value & #PB_ListIcon_Checked
    SetGadgetItemState(GadgetID, index, Selected)
  Else
    SetGadgetItemState(GadgetID, index, Selected | #PB_ListIcon_Checked)
  EndIf
EndProcedure



Procedure FindWindow(name$)
  hwnd.l = FindWindow_(0, 0)
  While hwnd <> 0
    If GetWindowLong_(hwnd, #GWL_STYLE) & #WS_VISIBLE = #WS_VISIBLE
      If GetWindowLong_(Hwnd, #GWL_EXSTYLE) & #WS_EX_TOOLWINDOW <> #WS_EX_TOOLWINDOW
        txt.s = Space (256)
        GetWindowText_(hwnd, txt, 256)
        If txt = name$
          ProcedureReturn hwnd
        EndIf
      EndIf
    EndIf
    hwnd = GetWindow_(hwnd, #GW_HWNDNEXT)
  Wend
  ProcedureReturn #Null
EndProcedure



Global DefPictureDirectory.s

CompilerIf #PB_Compiler_OS = #PB_OS_Windows
  
  Procedure.s GetKeyValue(topKey, sKeyName.s, sValueName.s) 
    hKey.l 
    lpData.s 
    lpcbData.l 
    lType.l 
    lReturnCode.l 
    GetValue.s 
    
    If Left(sKeyName, 1) = "\"
      sKeyName = Right(sKeyName, Len(sKeyName) - 1)
    EndIf 
    
    GetHandle.l = RegOpenKeyEx_(topKey, sKeyName, 0, #KEY_ALL_ACCESS, @hKey) 
    
    If GetHandle = #ERROR_SUCCESS 
      lpcbData = 255 : lpData = Space(255) 
      
      GetHandle = RegQueryValueEx_(hKey, sValueName, 0, @lType, @lpData, @lpcbData) 
      
      If GetHandle = #ERROR_SUCCESS 
        Select lType 
          Case #REG_SZ 
            GetHandle = RegQueryValueEx_(hKey, sValueName, 0, @lType, @lpData, @lpcbData) 
            
            If GetHandle = 0 
              GetValue = Left(lpData, lpcbData - 1) 
            Else 
              GetValue = "" 
            EndIf 
            
          Case #REG_DWORD 
            GetValue = ""
            
        EndSelect 
      EndIf 
    EndIf 
    RegCloseKey_(hKey) 
    ProcedureReturn GetValue
  EndProcedure 
  
  DefPictureDirectory = GetKeyValue(#HKEY_CURRENT_USER, "Software\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders\", "My Pictures")
  
CompilerElse
  
  DefPictureDirectory = "/"
  
CompilerEndIf

Procedure.s GetDefaultDirectory()
  ProcedureReturn DefPictureDirectory
EndProcedure

; IDE Options = PureBasic 4.50 (Windows - x86)
; CursorPosition = 17
; Folding = --