
#File = "data.ic"
Global nbDigitsForPictureIndex.l
Global RedimFailed.l = 0


Procedure LoadFromFile(*opt.Options)
  If FileSize(#File) = SizeOf(Options)
    hFile = ReadFile(#PB_Any, #File)
    If hFile
      *opt\CompressionLevel = ReadByte(hFile)
      *opt\RenameFiles      = ReadByte(hFile)
      *opt\MoveFolder       = ReadByte(hFile)
      *opt\DeleteOldImg     = ReadByte(hFile)
      *opt\ExtInLcase       = ReadByte(hFile)
      *opt\Language         = ReadCharacter(hFile)
      CloseFile(hFile)
      ProcedureReturn
    EndIf
  EndIf
  *opt\CompressionLevel = 5
  *opt\RenameFiles      = 0
  *opt\MoveFolder       = 0
  *opt\DeleteOldImg     = 0
  *opt\ExtInLcase       = 1
  *opt\Language         = GetLanguageToUse()
EndProcedure

Procedure SaveToFile()
  DeleteFile(#File)
  hFile = OpenFile(#PB_Any, #File)
  If hFile
    WriteByte(hFile, GetGadgetState(#Combo_Compression))
    WriteByte(hFile, GetGadgetState(#Chk_Rename))
    WriteByte(hFile, GetGadgetState(#Chk_ChangeFolder))
    WriteByte(hFile, GetGadgetState(#Chk_RemoveOldImg))
    WriteByte(hFile, GetGadgetState(#Chk_LcaseExt))
    WriteCharacter(hFile, Language)
    CloseFile(hFile)
  EndIf
EndProcedure






Procedure FileListing()
  
  ; on ferme l'ancienne fentre
  HideWindow(#Wnd_Main, #True)
  
  ; rcupration des valeurs
  Dossier = Trim(GetGadgetText(#Str_Folder))
  If Right(Dossier, 1) <> "\"
    Dossier = Dossier + "\"
  EndIf
  Formats = GetGadgetText(#Combo_Format)
  If GetGadgetState(#Chk_LcaseExt)
    Formats = LCase(Formats)
  EndIf
  Compression = Val(GetGadgetText(#Combo_Compression))
  FichiersVideo.l = 0
  
  ; on affiche la nouvelle fentre
  HideWindow(#Wnd_List, #False)
  SetActiveWindow(#Wnd_List)
  
  ; on liste tous les fichiers graphiques trouvs
  If ExamineDirectory(0, Dossier, "*.*")
    Repeat
      fileType.l = NextDirectoryEntry(0)   ; recupration du type du fichier
      
      ; analyse sur les fichiers
      If fileType = 1
        file.s = DirectoryEntryName(0)
        ok.b = 0
        Ext.s = LCase(GetExtensionPart(file))
        For i.b = 1 To nbExtension
          If Extension(i) = Ext
            ok = 1
          EndIf
        Next i
        
        If ok ; le fichier est un fichier graphique
          AddElement(fichiers())
          fichiers() = file
        ElseIf FindString(#VIDEO_EXT$, ";"+Ext+";", 1)
          FichiersVideo + 1
          HideGadget(#Text_WarningVideos, #False)
        EndIf
      EndIf
      
    Until fileType = 0  ; tant que le dossier n'est pas vide
  ;Else
  ;  Debug "Impossible d'analyser le dossier !!!"
  EndIf
  
  If ListSize(fichiers()) = 0
    MessageRequester(#PROJECT_NAME$, Translate("Info.EmptyFolder1")+Chr(13)+Chr(10)+"  "+Translate("Info.EmptyFolder2"), #PB_MessageRequester_Ok)
    End
  EndIf
  
  
  ; on ajoute les fichiers  la liste (et on coche la case)
  ForEach fichiers()
    AddGadgetItem(#Lst_Images, -1, fichiers()+Chr(10)+SizeToStr(FileSize(Dossier+fichiers())))
    SetGadgetItemState(#Lst_Images, ListIndex(fichiers()), #PB_ListIcon_Checked)
  Next
  
EndProcedure












Procedure.s GetPattern__old(Extension.s)
  #My_Pictures_Pattern = #DEFAULT_FILENAME
  Protected Pattern.s = ""
  Protected Title.s, Text.s, Defaut.s
  
  mask.l = GetGadgetState(#Chk_Rename) + 2*GetGadgetState(#Chk_ChangeFolder)
  If mask
    Extension = "." + Extension
    Select mask
      Case 1
        Defaut = #My_Pictures_Pattern + Extension
      Case 2
        Defaut = GetDefaultDirectory()
      Case 3
        Defaut = GetDefaultDirectory() + "\" + #My_Pictures_Pattern + Extension
    EndSelect
    
    While Pattern = ""
      Select mask
        Case 1
          Title  = Translate("Info.Pattern.Title1")
          Text   = Translate("Info.Pattern.Text1")
        Case 2
          Title  = Translate("Info.Pattern.Title2")
          Text   = Translate("Info.Pattern.Text2")
        Case 3
          Title  = Translate("Info.Pattern.Title3")
          Text   = Translate("Info.Pattern.Text1")
      EndSelect
      Pattern = InputRequester(Title, Text, Defaut)
      If Pattern = ""
        If MessageRequester(#PROJECT_NAME$, Translate("Info.Pattern.Quit"), #MB_ICONWARNING | #PB_MessageRequester_YesNo) = #PB_MessageRequester_Yes
          End
        EndIf
      Else
        Defaut = Pattern
        Select mask
          Case 1
            If FindString(Pattern, "#", 1) = 0
              Alert(Translate("Info.Pattern.Error1"))
              Pattern = ""
            ElseIf FindString(Pattern, "\", 1)
              Alert(Translate("Info.Pattern.Error2"))
              Pattern = ""
            EndIf
          Case 2
            If Right(Pattern, 1) <> "\"
              Pattern + "\"
            EndIf
            If MakeSureDirectoryPathExists_(Pattern) = 0
              Alert(Translate("Info.Pattern.Error3"))
              Pattern = ""
            EndIf
          Case 3
            If FindString(Pattern, "#", 1) = 0
              Alert(Translate("Info.Pattern.Error1"))
              Pattern = ""
            ElseIf MakeSureDirectoryPathExists_(GetPathPart(Pattern)) = 0
              Alert(Translate("Info.Pattern.Error3"))
              Pattern = ""
            EndIf
        EndSelect
      EndIf
    Wend
    
    If mask <> 2
      If Right(LCase(Pattern), Len(Extension)) <> LCase(Extension)
        Pattern + Extension
      EndIf
    EndIf
  EndIf
  ProcedureReturn Pattern
EndProcedure


Procedure.s GetPattern(Extension.s)
  Extension = "." + Extension
  Folder$ = GetGadgetText(#Str_Folder2)
  FileName$= GetGadgetText(#Str_Name)
  If GetGadgetState(#Chk_Rename)
    If GetGadgetState(#Chk_ChangeFolder)
      ProcedureReturn Path_Combine(Folder$, FileName$) + Extension
    Else
      ProcedureReturn GetGadgetText(#Str_Name) + Extension
    EndIf
  Else
    If GetGadgetState(#Chk_ChangeFolder)
      ProcedureReturn GetGadgetText(#Str_Folder2)
    Else
      ProcedureReturn ""
    EndIf
  EndIf
EndProcedure





; ###################################################################################
;- ___ Procedure qui compresse une seule image  ________
; ###################################################################################

Procedure MyLoadImage(image$)
  Protected tentativesRestantes.l
  
  tentativesRestantes = 5
  While tentativesRestantes 
    hImage = LoadImage(#PB_Any, image$)
    If hImage
      ProcedureReturn hImage
    EndIf
    tentativesRestantes - 1
  Wend
  ProcedureReturn 0
EndProcedure





Procedure DeleteImage(file.s, hImage.l)
  Protected msg.s
  
  While DeleteFile(file) = 0
    msg = Translate("Info.DeleteImage.Text1")+" :" + Chr(10) + file + Chr(10) 
    msg + Translate("Info.DeleteImage.Text2")
    msg + Chr(10) + Chr(10) + Translate("Info.DeleteImage.Text3")
    If MessageRequester(#PROJECT_NAME$, msg, #MB_ICONERROR | #PB_MessageRequester_YesNo) = #PB_MessageRequester_No
      FreeImage(hImage)
      ProcedureReturn #False
    EndIf
  Wend
  ProcedureReturn #True
EndProcedure





Procedure.s ReplaceDieseByFormattedIndex(Pattern.s, index.l)
  number.s = Str(index)
  If nbDigitsForPictureIndex > Len(number)
    number = RSet(number, nbDigitsForPictureIndex, "0")
  EndIf
  ProcedureReturn ReplaceString(Pattern, "#", number)
EndProcedure

Procedure CompresseImage(img.s, Pattern.s, number.l)
  Protected out.s, in.s
  Protected Loaded.b = #False, DateCreat, DateModif
  
  in = Dossier+img
  While Loaded = #False
    hImage = MyLoadImage(in)
    If hImage
      DateCreat = GetFileDate(in, #PB_Date_Created)
      DateModif = GetFileDate(in, #PB_Date_Modified)
      Loaded = #True
      If Pattern
        If Right(Pattern, 1) = "\"
          out = Pattern + Left(img,Len(img)-Len(GetExtensionPart(img)) ) + Formats
        ElseIf FindString(Pattern, "\", 1)
          out = ReplaceDieseByFormattedIndex(Pattern, number)
        Else
          out = Dossier + ReplaceDieseByFormattedIndex(Pattern, number)
        EndIf
      Else
        out = Dossier + Left(img,Len(img)-Len(GetExtensionPart(img)) ) + Formats
      EndIf
      
      If LCase(in) = LCase(out)
        If DeleteImage(in, hImage) = 0
          ProcedureReturn
        EndIf
      Else
        While FileSize(out) >= 0
          Select MessageRequester(#PROJECT_NAME$+" - "+Translate("Info.FileOverwrite.Title"), ReplaceString(Translate("Info.FileOverwrite.Message"), "%", out), #PB_MessageRequester_YesNoCancel | #MB_ICONWARNING)
            Case #PB_MessageRequester_Yes
              If DeleteImage(out, hImage) = 0
                ProcedureReturn
              EndIf
            Case #PB_MessageRequester_No
              out = InputRequester(Translate("Info.FileOverwrite.New.Title"), Translate("Info.FileOverwrite.New.Message")+" :", out)
            Case #PB_MessageRequester_Cancel
              ProcedureReturn
          EndSelect
        Wend
      EndIf
      
      ; redimension de l'image
      If ImageSizeRatio <> 1
        width  = ImageSizeRatio * ImageWidth(hImage)
        height = ImageSizeRatio * ImageHeight(hImage)
        If ResizeImage(hImage, width, height) = 0
          msg$ = Translate("Info.UnableRedimImage")
          option = 0
          If RedimFailed = 0
            msg$ + #CRLF$ + Translate("Info.DisableImageRedim")
            option = #PB_MessageRequester_YesNo
          EndIf
          If Alert(ReplaceString(msg$, "%", img), option) = #PB_MessageRequester_Yes
            ImageSizeRatio = 1.0
          EndIf
          RedimFailed + 1
        EndIf
      EndIf
      
      ; enregistrement de l'image  
      r.l = 0
      While r = 0
        Select Formats
          Case "BMP", "bmp":  r = SaveImage(hImage, out, #PB_ImagePlugin_BMP)
          Case "PNG", "png":  r = SaveImage(hImage, out, #PB_ImagePlugin_PNG)
          Case "JPG", "jpg":  r = SaveImage(hImage, out, #PB_ImagePlugin_JPEG, Compression)
        EndSelect
        If r = 0 ; problme lors de l'enregistrement de l'image
          Select MessageRequester(#PROJECT_NAME$, Translate("Info.UnableSaveImage.Title")+" :" + Chr(10) + out + Chr(10) + Chr(10) + Translate("Info.UnableSaveImage.Message"), #MB_ICONWARNING | #PB_MessageRequester_YesNoCancel)
            Case #PB_MessageRequester_Yes
              out = InputRequester(Translate("Info.FileOverwrite.New.Title"), Translate("Info.FileOverwrite.New.Message")+" :", out)
            Case #PB_MessageRequester_No
              ; do nothing !
            Case #PB_MessageRequester_Cancel
              r = -1 ; on sort de la boucle malgr que l'image n'est pas pu tre enregistre...
          EndSelect
        Else
          SetFileDate(out, #PB_Date_Created,  DateCreat)
          SetFileDate(out, #PB_Date_Modified, DateModif)
        EndIf
      Wend
      
      FreeImage(hImage)
      
      If r = #True And LCase(in) <> LCase(out)
        If GetGadgetState(#Chk_RemoveOldImg)
          Repeat
            r = DeleteFile(in)
            If r = #Null
              If MessageRequester(#PROJECT_NAME$, Translate("Info.UnableDeleteImage.Text1")+" :" + Chr(10) + in + Chr(10) + Chr(10) + Translate("Info.TryAgain"), #MB_ICONWARNING | #PB_MessageRequester_YesNo) = #PB_MessageRequester_No
                r = #True
              EndIf
            EndIf
          Until r
        EndIf
      EndIf
    Else ; Not loaded !!!
      If MessageRequester(#PROJECT_NAME$, ReplaceString(Translate("Info.LoadImageFailed.Text2"), "%", img) + Chr(10) + Translate("Info.TryAgain"), #MB_ICONWARNING | #PB_MessageRequester_YesNo) = #PB_MessageRequester_No
        Loaded = #True ; -> stop the loop !
      EndIf
    EndIf
  Wend
EndProcedure






; ###################################################################################
;- ___ Procedure Lancement de la compression des images  _________
; ###################################################################################

Procedure CompresseImages(*Pattern.l)
  Protected max.l
  Pattern.s = PeekS(*Pattern)
  If FindString(Pattern, "\", 1)
    MakeSureDirectoryPathExists_(GetPathPart(Pattern))
  EndIf
  start = Val(GetGadgetText(#Str_StartAt))
  If start < 1
    start = 1
  EndIf
  max = ListSize(fichiers()) + start - 1
  nbDigitsForPictureIndex = Len(Str(max)) 
  If nbDigitsForPictureIndex < 3
    nbDigitsForPictureIndex = 3
  EndIf
  ForEach fichiers()
    If GetGadgetItemState(#Lst_Images,ListIndex(fichiers())) & #PB_ListIcon_Checked
      CompresseImage(fichiers(), Pattern, fileDone + start)
      fileDone + 1
    EndIf
  Next
  If GetGadgetState(#Chk_OpenFolder)
    RunProgram(OutputDirectory)
  EndIf
  
  SaveToFile()
  ImageProcessingStoppedOrDone = #True
EndProcedure





; ###################################################################################
;- ___ Procedure Lancement de la compression des images  _________
; ###################################################################################


Procedure DefineImageRatio()
  errPrefix$ = Translate("Info.NewSize.ErrorPrefix")+": "
  ratio$ = Trim(GetGadgetText(#Str_Size))
  
  ; ____Fraction case_____
  If CountString(ratio$, "/") = 1
  
    left$ = Trim(StringField(ratio$, 1, "/"))
    right$ = Trim(StringField(ratio$, 2, "/"))
    If IsInteger_(left$) And IsInteger_(right$)
      left.l  = Val(left$)
      right.l = Val(right$)
      If right = 0
        Alert(errPrefix$+Translate("Info.NewSize.Error1"))
        ProcedureReturn #False
      Else
        ImageSizeRatio = (1.0*left)/right
      EndIf
    Else
      Alert(errPrefix$+Translate("Info.NewSize.Error2"))
      ProcedureReturn #False
    EndIf
  
  ;  ____Pour-cent case_____
  ElseIf Right(ratio$, 1) = "%"
  
    pCent$ = Trim(Left(ratio$, Len(ratio$)-1))
    If IsInteger_(pCent$)
      pCent.l = Val(pCent$)
      If pCent < 1
        Alert(errPrefix$+Translate("Info.NewSize.Error3"))
        ProcedureReturn #False
      Else
        ImageSizeRatio = pCent/100
      EndIf
    Else
      Alert(errPrefix$+Translate("Info.NewSize.Error4"))
      ProcedureReturn #False
    EndIf
  
  ;  ____Float case_____
  ElseIf IsFloat_(ratio$)
    
    ReplaceString(ratio$, ",", ".", #PB_String_InPlace)
    ImageSizeRatio = ValF(ratio$)
  
  ;  ____Undefined case_____
  Else 
    Alert(errPrefix$+Translate("Info.NewSize.Error5"))
    ProcedureReturn #False
  EndIf
  
  msg$ = Translate("Info.NewSize.Message")+#CRLF$+Translate("Info.Continue")
  msg$ = ReplaceString(msg$, "#", StrF(ImageSizeRatio*100, 1))
  Select Alert(msg$, #PB_MessageRequester_YesNoCancel)
    Case #PB_MessageRequester_Cancel: ProcedureReturn #False
    Case #PB_MessageRequester_No: End
    Case #PB_MessageRequester_Yes: ProcedureReturn #True
  EndSelect
EndProcedure






; IDE Options = PureBasic 4.50 (Windows - x86)
; CursorPosition = 291
; FirstLine = 265
; Folding = --
; UseMainFile = ImagesCompressor.pb