
#HASH_TRIM_KEY  = 1
#HASH_TRIM_VAL  = 2
#HASH_TRIM_BOTH = #HASH_TRIM_KEY | #HASH_TRIM_VAL


Structure Hash
  key.s
  val.s
EndStructure


Procedure.s Hash_Find(List Hash.Hash(), Key$, NotFoundValue$ = #NULL$)
  ForEach Hash()
    If Hash()\key = Key$
      ProcedureReturn Hash()\val
    EndIf
  Next
  ProcedureReturn NotFoundValue$
EndProcedure


Procedure Hash_Add(List Hash.Hash(), Key$, Value$)
  AddElement(Hash())
  Hash()\key = Key$
  Hash()\val = Value$
EndProcedure


Procedure.l Hash_Create(List Hash.Hash(), File$, Separator$ = "=", Trims.b = #HASH_TRIM_BOTH, FileFormat = #PB_Ascii)
  Protected hFile.l, Line$, key$, val$, rest.l, count.l = 0
  LastElement(Hash())
  hFile = ReadFile(#PB_Any, File$)
  If hFile
    While Eof(hFile) = #False
      Line$ = ReadString(hFile, FileFormat)
      If Len(Trim(Line$))
        key$ = StringField(Line$, 1, Separator$)
        rest = Len(Line$) - (Len(key$) + Len(Separator$))
        If rest >= 0
          val$ = Right(Line$, rest)
          If Trims & #HASH_TRIM_KEY: key$ = Trim(key$) : EndIf
          If Trims & #HASH_TRIM_VAL: val$ = Trim(val$) : EndIf
          Hash_Add(Hash(), key$, val$)
          count + 1
        EndIf
      EndIf
    Wend
    CloseFile(hFile)
    ProcedureReturn count
  EndIf
  ProcedureReturn #Null
EndProcedure



; IDE Options = PureBasic 4.31 (Windows - x86)
; CursorPosition = 44
; FirstLine = 12
; Folding = -
; EnableXP
; UseMainFile = ImagesCompressor.pb