; ####################################################################################
; #  Programme permettant de compresser les images d'un dossier selon le format et   #
; #               le taux de compression slectionn par l'utilisateur.              #
; #                                                                                  #
; #     @ auteur : Lionel                                                            #
; #     @ date : vendredi 12 Novenbre 2004                                           #
; #     @ date : corrections le 26 mars 2008                                         #
; #     @ date : corrections le 04 mars 2009                                         #
; ####################################################################################



; chargement des dcodeurs et encodeurs
UseJPEGImageDecoder()
UseJPEGImageEncoder()
UsePNGImageDecoder()
UsePNGImageEncoder()

Structure Options
  CompressionLevel.b
  RenameFiles.b
  MoveFolder.b
  DeleteOldImg.b
  ExtInLcase.b
  Language.c
EndStructure

Global Dim Extension.s(10)
Global NewList fichiers.s()
Global nbExtension.l
Global Dossier.s, Formats.s, Compression.l
Global fileDone.l, nbFileToConvert.l
Global nbExtension.l
Global ImageSizeRatio.f = 1
Global ImageProcessingStoppedOrDone = #False
Global BrowseBtn1Used.b = #False, BrowseBtn2Used.b = #False
Global OutputDirectory.s
Global Language.c


#PROJECT_NAME$    = "Images Compressor"
#VIDEO_EXT$       = ";avi;mpeg;mpg;mov;"
#IMAGE_EXT$       = "bmp,jpg,jpeg,png"
#DEFAULT_FILENAME = "Nouvel album #"
#VERSION_NUMBER   = "2.5.1"

#StartProcess   = 2
#RATE           = 500


; chargement des formats supports
Restore FormatsGraphiques
nbExtension = CountString(#IMAGE_EXT$, ",")+1
For i = 1 To nbExtension
  Extension(i) = StringField(#IMAGE_EXT$, i, ",")
Next i



; Include
IncludeFile "Hash.pb"
IncludeFile "Localization.pb"
IncludeFile "BasicFcts.pb"
IncludeFile "Graph.pb"
IncludeFile "Functions.pb"







;- Gestion des vnements

LoadFromFile(Options.Options)
Language = Options\Language
InitLanguage(Language)
CreateWindows(Options)
SaveToFile()

Text.s = GetClipboardText()
If Text And FileSize(Text) = -2
  SetGadgetText(#Str_Folder, Text)
EndIf


exit = #False
Repeat
  EventID = WaitWindowEvent()
  
  If EventID = #PB_Event_Gadget  ; on a fait une action sur un des gadgets
    
    Select EventGadget()
      
      Case #Str_Folder
        ; ractualisation du boutton 'lister'
        If FileSize(GetGadgetText(#Str_Folder)) = -2
          DisableGadget(#Btn_List, 0) 
        Else
          DisableGadget(#Btn_List, 1)
        EndIf
        
      Case #Btn_Browse  ; appel du PathRequester()
        a.s = PathRequester(Translate("Info.FolderSelection"),Trim(GetGadgetText(#Str_Folder)))
        If a <> ""
          BrowseBtn1Used = #True
          SetGadgetText(#Str_Folder, a)
        EndIf
      
      Case #Btn_Browse2  ; appel du PathRequester()
        a.s = PathRequester(Translate("Info.FolderSelection"),Trim(GetGadgetText(#Str_Folder2)))
        If a <> ""
        BrowseBtn2Used = #True
          SetGadgetText(#Str_Folder2, a)
        EndIf

      Case #Combo_Format ; Liste des formats
        If GetGadgetText(#Combo_Format) = "JPEG" Or GetGadgetText(#Combo_Format) = "JPG"
          DisableGadget(#Combo_Compression, 0)
        Else
          DisableGadget(#Combo_Compression, 1)
        EndIf
      
      Case #Btn_Paste
        Text.s = GetClipboardText()
        If Text
          SetGadgetText(#Str_Folder, Text)
        EndIf
      
      Case #Combo_Size
        state = GetGadgetState(#Combo_Size)
        HideGadget(#Text_Size2, state): HideGadget(#Str_Size, state)

      Case #Btn_Quit ; on quitte le programme
         End
        
      Case #Btn_List ; listage des fichiers images
        ok = #True
        Select GetGadgetState(#Combo_Size)
          Case 1: ImageSizeRatio = 0.2
          Case 2: ImageSizeRatio = 1/3
          Case 3: ImageSizeRatio = 0.25
          Case 4: ImageSizeRatio = 0.5
          Case 5: ImageSizeRatio = 3/2
          Case 6: ImageSizeRatio = 1.0
          Case 7: ImageSizeRatio = 1.5
          Case 8: ImageSizeRatio = 2.0
          Case 9: ImageSizeRatio = 3.0
          Case 10: ImageSizeRatio = 4.0
          Default: ok = DefineImageRatio()
        EndSelect
        If ok
          FileListing()
        EndIf
        
      
      Case #Chk_Rename
        DisableGadget(#Str_Name, False(GetGadgetState(#Chk_Rename)))
        DisableGadget(#Str_StartAt, False(GetGadgetState(#Chk_Rename)))
      
      Case #Chk_ChangeFolder
        DisableGadget(#Str_Folder2, False(GetGadgetState(#Chk_ChangeFolder)))
        DisableGadget(#Btn_Browse2, False(GetGadgetState(#Chk_ChangeFolder)))
        
      
      Case #Btn_ReglerLesOptions
        HideWindow(#Wnd_List, #True)
        fileDone = 0
        nbFileToConvert = 0
        ForEach fichiers() 
          If GetGadgetItemState(#Lst_Images,ListIndex(fichiers())) & #PB_ListIcon_Checked
            nbFileToConvert + 1
          EndIf
        Next
        SetGadgetText(#Text_Nb_Images, ReplaceString(Translate("Text.Params"), "%", Str(nbFileToConvert)))
        HideWindow(#Wnd_Options, #False)
        
      
        
      Case #Lst_Images
        If GetGadgetState(#Lst_Images) = -1
          SetToogleButtonsState(#True)
        Else
          SetToogleButtonsState(#False)
        EndIf
      
      Case #Btn_Toggle_After
        index = GetGadgetState(#Lst_Images)
        count = CountGadgetItems(#Lst_Images)
        If index <> - 1
          index + 1
          While index < count
            InverseCheckBox(#Lst_Images, index)
            index + 1
          Wend
        EndIf
        SetActiveGadget(#Lst_Images)
        
      Case #Btn_Toggle_Before
        index = GetGadgetState(#Lst_Images)
        If index <> - 1
          index - 1
          While index >= 0
            InverseCheckBox(#Lst_Images, index)
            index - 1
          Wend
        EndIf
        SetActiveGadget(#Lst_Images)
        
      Case #Btn_StartProcess
        If ReadyForEncoding()
          FilePattern.s = GetPattern(Formats)
          
          If FindString(FilePattern, "\", 1)
            OutputDirectory = GetPathPart(FilePattern)
          Else
            OutputDirectory = Dossier
          EndIf
          
          ThreadID = CreateThread(@CompresseImages(), @FilePattern)
          Goto Process
        EndIf
    EndSelect

  ElseIf EventID = #PB_Event_CloseWindow
    exit = #True
  EndIf

Until exit

If exit <> #StartProcess
  End
EndIf





;- Affichage de la progression des convertions/compressions
Process:


CheckOpenWnd = False(BrowseBtn2Used) And (GetGadgetState(#Chk_ChangeFolder) XOr BrowseBtn1Used)
If False(CheckOpenWnd)
  CheckOpenWnd = False(FindWindow(OutputDirectory))
EndIf
SetGadgetState(#Chk_OpenFolder, CheckOpenWnd)

HideWindow(#Wnd_Options, #True)
HideWindow(#Wnd_Process, #False)
time2 = 0

While ImageProcessingStoppedOrDone = #False
  EventID = WaitWindowEvent(50)
  time = ElapsedMilliseconds()
  
  If EventID = #PB_Event_CloseWindow  ; If the user has pressed on the close button
    If ThreadID
      KillThread(ThreadID)
    EndIf
    End
  ElseIf EventID = #PB_Event_Gadget
    If EventGadget() = #Btn_CancelProcess ; Annuler ???
      PauseThread(ThreadID)
      If MessageRequester(#PROJECT_NAME$+" - "+Translate("Info.StopThread.Title"), Translate("Info.StopThread.Message"), #PB_MessageRequester_YesNo) = #PB_MessageRequester_Yes
        KillThread(ThreadID)
        End
      Else
        ResumeThread(ThreadID)
      EndIf
    EndIf
  EndIf
  
  
  If time - #RATE > time2 And nbFileToConvert > 0
    SetGadgetText(#Text_5, Str(fileDone) + "/" + Str(nbFileToConvert))
    SetGadgetState(#ProgressBar, (fileDone*100)/nbFileToConvert)
    SetWindowTitle(#Wnd_Process, Str((fileDone*100)/nbFileToConvert) + "% - " + #PROJECT_NAME$)
    time2 = time
  EndIf
  
Wend
End



; ###################################################################################
;- ___ Zone de donnees pour les formats graphiques pris en cpte ________
; ###################################################################################

DataSection
  FormatsGraphiques:
    Data.s "bmp", "jpg", "jpeg", "png", "-1"
  LangFrStart:
    IncludeBinary #LOC_FOLDER+"fr_Franais.ini"
  LangFrEnd:
  LangEnStart:
    IncludeBinary #LOC_FOLDER+"en_English.ini"
  LangEnEnd:
EndDataSection

; IDE Options = PureBasic 4.50 (Windows - x86)
; CursorPosition = 33
; FirstLine = 15
; UseIcon = icone.ico
; Executable = ImagesCompressor.exe
; IncludeVersionInfo
; VersionField0 = 2.5.1
; VersionField1 = 2.5.1
; VersionField2 = Lionel Luchez
; VersionField3 = Images Compressor
; VersionField4 = 2.5.1
; VersionField5 = 2.5.1
; VersionField9 = GNU by Lionel Luchez
; VersionField14 = http://basicunivers.free.fr/