
#TempFile = "temp.tmp"
#LOC_FOLDER = "langs\"
#LANG_FR_CODE = 'f'
#LANG_EN_CODE = 'e'

Global NewList Lang.Hash()


ProcedureDLL.s System_GetCurrentLanguage()
  Protected sLanguage.s
  CompilerSelect #PB_Compiler_OS
    CompilerCase #PB_OS_Linux ;{
      sLanguage = GetEnvironmentVariable("LANG")
      ;}
    CompilerCase #PB_OS_MacOS ;{
      ; http://developer.apple.com/documentation/MacOSX/Conceptual/BPInternational/Articles/ChoosingLocalizations.html#//apple_ref/doc/uid/20002397-SW4
      ;}
    CompilerCase #PB_OS_Windows ;{
      #LOCALE_SISO639LANGNAME = 89
      #LOCALE_SISO3166CTRYNAME = 90
      
      Protected sBuffer.s
      Protected lBufferLen.l = 1000
      sBuffer=Space(lBufferLen)
      GetLocaleInfo_(#LOCALE_SYSTEM_DEFAULT, #LOCALE_SISO639LANGNAME, sBuffer, lBufferLen)
      sLanguage = sBuffer
      
      sBuffer=Space(lBufferLen)
      GetLocaleInfo_(#LOCALE_SYSTEM_DEFAULT, #LOCALE_SISO3166CTRYNAME, sBuffer, lBufferLen)
      sLanguage + "_" + sBuffer
      ;} 
  CompilerEndSelect
  ProcedureReturn sLanguage
EndProcedure


Procedure.c GetLanguageToUse()
  hReg = CreateRegularExpression(#PB_Any, "(^|_)fr(_|$)")
  res = MatchRegularExpression(hReg, System_GetCurrentLanguage())
  FreeRegularExpression(hReg)
  If res
    ProcedureReturn #LANG_FR_CODE
  Else
    ProcedureReturn #LANG_EN_CODE
  EndIf
EndProcedure



Procedure InitLanguage(LangCode.c)
  
  Select LangCode
    Case #LANG_FR_CODE: starts = ?LangFrStart: ends = ?LangFrEnd: Err$ = "Veuillez lancer % depuis un rpertoire avec des droits d'accs en criture !"
    Default: starts = ?LangEnStart: ends = ?LangEnEnd : Err$ = "Please, run % from a directoty with writing access !"
  EndSelect
  Content$ = PeekS(starts, ends - starts)
  hFile = CreateFile(#PB_Any, #TempFile)
  If hFile
    WriteString(hFile, Content$)
    CloseFile(hFile)
    res = Hash_Create(Lang(), #TempFile)
    DeleteFile(#TempFile)
    If res
      ProcedureReturn #True
    EndIf
  EndIf
  MessageRequester(#PROJECT_NAME$, ReplaceString(Err$, "%", #PROJECT_NAME$), #MB_ICONERROR)
  End
EndProcedure


Macro Translate(Key)
  Hash_Find(Lang(), Key)
EndMacro  


; IDE Options = PureBasic 4.31 (Windows - x86)
; CursorPosition = 38
; FirstLine = 33
; Folding = --
; EnableXP
; UseMainFile = ImagesCompressor.pb